
#include "cd3d.h"
#include "cdMd3.h"

LRESULT WINAPI WinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
		break;
		case WM_KEYUP: 
            switch (wParam)
			{ 
                case VK_ESCAPE:
	                DestroyWindow(hWnd);
					return 0;
		        break;
            } 
        break;

    }

    return DefWindowProc(hWnd, msg, wParam, lParam);
}

INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, INT)
{
    WNDCLASSEX wc = {sizeof(WNDCLASSEX), CS_CLASSDC, WinProc, 0L, 0L, 
                     GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                     "cd3d", NULL};
    RegisterClassEx(&wc);

    HWND hWnd = CreateWindow("cd3d", "3000 Interaktiv: cd3d", 
                              WS_OVERLAPPEDWINDOW, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
                              GetDesktopWindow(), NULL, wc.hInstance, NULL);



	// Ein paar bentigte Variablen (nicht wichtig fr Md3's)
	D3DCOLORVALUE			rgbaDiffuse			= {1.0, 1.0, 1.0, 0.0,};
	D3DCOLORVALUE			rgbaAmbient			= {1.0, 1.0, 1.0, 0.0,};
	D3DCOLORVALUE			rgbaSpecular		= {0.0, 0.0, 0.0, 0.0,};
	D3DCOLORVALUE			rgbaEmissive		= {0.0, 0.0, 0.0, 0.0,};

	cd3d game(hWnd, 1024, 768);		//Erzeugen des Spieleobjekts.
	game.setLight();
	game.setMaterial(rgbaDiffuse, rgbaAmbient, rgbaSpecular, rgbaEmissive, 0);
	
	cdMatrix mat(game.g_pD3DDevice);	//Erzeugen des Matrixobjekts.
	
	cdMd3 model(game.g_pD3DDevice, "Held");	//Hier legen wir die Modelklasse an.
	model.SetUpperAni(TORSO_STAND);					//Legen die Torso und
	model.SetLowerAni(LEGS_WALK);					//Beinanimation fest.

	float move=0;

    ShowWindow(hWnd, SW_SHOWDEFAULT);
    UpdateWindow(hWnd);

	MSG msg; 
    BOOL fMessage;

	PeekMessage(&msg, NULL, 0U, 0U, PM_NOREMOVE);

	while(msg.message != WM_QUIT)
	{
		fMessage = PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE);

		if(fMessage)
		{
			TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
		else
		{
			move += 0.1f;

			game.RenderBegin();				//Beginn des Rendervorgangens.
				mat.RotateX(move/10);		//Rotation u die X Achse.
				mat.RotateY(move/10);		//Rotation u die Y Achse.
				model.Render(mat.matWorld);	//Rendern unseres Models.
				mat.Identity();				//Leeren der Matrizen.
			game.RenderEnd();				//Ende des Rendervorgangs.
		}

	}

	game.CleanUp();

	UnregisterClass("cd3d", wc.hInstance);
    
	return 0;
}