
#include <stdio.h>
#include <d3dx8.h>
#include <string>
#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include <fstream>

using namespace std;

#pragma comment(lib, "dxguid.lib") 
#pragma comment(lib, "d3dx8.lib")

#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)
#define D3DFVF_CUSTOMVERTEX2 (D3DFVF_XYZ|D3DFVF_DIFFUSE)
#define SafeDelete(pObject) if(pObject != NULL) {delete pObject; pObject=NULL;}
#define KEYDOWN(name, key) (name[key] & 0x80)
#define MOUSEBUTTONDOWN(key) (key & 0x80)
#define MOUSEBUTTON_LEFT 0
#define MOUSEBUTTON_RIGHT 1
#define MOUSEBUTTON_MIDDLE 2
#define DELETE_ARRAY(x)	 { if ((x) != NULL) delete [](x);(x) = NULL; }

struct TVertex
{
	D3DXVECTOR3		position;
	D3DXVECTOR3		normal;	
	FLOAT			tu, tv;	
};

struct CUSTOMVERTEX
{
    D3DXVECTOR3		position;
    DWORD			colour;
};

class cd3d
{
	private:
		LPDIRECT3D8				g_pD3D;
		D3DDISPLAYMODE			d3ddm;
		D3DPRESENT_PARAMETERS	d3dpp;
		D3DLIGHT8				d3dLight;
		D3DMATERIAL8			m_matMaterial;
		D3DXMATRIX				matProj;

	public:
		LPDIRECT3DDEVICE8		g_pD3DDevice;
		D3DXMATRIX				matView;

		cd3d(HWND hWnd, UINT Width, UINT Height);
		void RenderBegin();
		void RenderEnd();
		void CleanUp();
		void setLight();
		void setMatrices();
		void setMaterial(D3DCOLORVALUE rgbaDiffuse, D3DCOLORVALUE rgbaAmbient, D3DCOLORVALUE rgbaSpecular, D3DCOLORVALUE rgbaEmissive, float rPower);
};

class cdMatrix
{
	private:
		LPDIRECT3DDEVICE8		D3D_Device;
		D3DXMATRIX				matTemp;

	public:
		cdMatrix(LPDIRECT3DDEVICE8 Device);
		void Translate(float x, float y, float z);
		void RotateX(float angle);
		void RotateY(float angle);
		void RotateZ(float angle);
		void Scale(float x, float y, float z);
		void Identity();

		D3DXMATRIX				matWorld;
};


