
#include "cd3d.h"

//Diese Klasse ist sehr leicht zu verstehen und sollte nicht unbedingt 
//weiter betrachtet werden. Wir bentigen sie im Prinzip nur fr
//die Worldmatrix. Ich fand es schn das Ganze in eine Klasse zu packen.

cdMatrix::cdMatrix(LPDIRECT3DDEVICE8 Device)
{
	D3D_Device = Device;
	D3DXMatrixIdentity(&matWorld);
}

void cdMatrix::Translate(float x, float y, float z)
{    
    D3DXMatrixTranslation(&matTemp, x, y, z);
    D3DXMatrixMultiply(&matWorld, &matWorld, &matTemp);
    D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);
}

void cdMatrix::RotateX(float angle)
{    
	D3DXMatrixRotationX(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matWorld, &matTemp);
	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);    
}

void cdMatrix::RotateY(float angle)
{    
	D3DXMatrixRotationY(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matWorld, &matTemp);
	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);    
}

void cdMatrix::RotateZ(float angle)
{    
	D3DXMatrixRotationZ(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matWorld, &matTemp);
	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);    
}
void cdMatrix::Scale(float x, float y, float z)
{    
    D3DXMatrixScaling(&matTemp, x, y, z);
    D3DXMatrixMultiply(&matWorld, &matWorld, &matTemp);
    D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);
}
void cdMatrix::Identity()
{    
	D3DXMatrixIdentity(&matWorld);
	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);
}