
#include "cdMd3.h"

//Smtliche Arbeit wird in dieser Klasse aufbereitet. Ich kann es nur jedem empfehlen
//sich das mal genauer anzuschauen, kann nicht schaden. Um die Klasse allerdings Spiele-
//tauglich zu machen mssen ein paar sehr kleine Dinge verndert werden. Die Namen,
//welche als Parameter an die Objekte bergeben werden, sind nur sehr unflexibel.
//Die nderungen stellen aber sicherlich kein Problem dar.

cdMd3::cdMd3(LPDIRECT3DDEVICE8 Device, LPSTR pFilename)
{
	char path[1024];

	D3D_Device = Device;					//Der Konstrukter unserer Klasse.

	for(int i=0; i<=10; i++)				//setzten der Texturen auf NULL;
		TexInf[i]=NULL;

	sprintf(path, "%s_animation.cfg", pFilename);	
	ReadAnimationFile(path);				//wir lesen die Animationfile aus.

	LoadMD3(pFilename);						//und fllen unsere Werte.
}

cdMd3::~cdMd3()								//Der Destruktor
{
	for(int i=0; i<=10; i++)
		SafeRelease(TexInf[i]);				//wir geben den Speicherplatz der Texturen wieder her.
}

void cdMd3::ReadAnimationFile(LPSTR strConfigFile)
{
	//Im Grunde, ldt diese Methode immer eine Zeile aus der Animationfile aus
	//und verarbeitet sie entsprechend dessen Inhalts.

	// "0	31	0	25		// BOTH_DEATH1"

	//ist so eine Zeile. Wir speichern die 5 Werte ab, welche wir wir gebrauchen.

	ifstream fin(strConfigFile);

	if( fin.fail() )
	{
		return;
	}

	string strWord = "";		
	string strLine = "";				
	int currentAnim = 0;				
	int torsoOffset = 0;			

	while(fin >> strWord)
	{
		if(!isdigit( strWord[0] ))
		{
			getline(fin, strLine);
			continue;
		}

		int startFrame = atoi(strWord.c_str());
		int numOfFrames = 0, loopingFrames = 0, framesPerSecond = 0;
		
		fin >> numOfFrames >> loopingFrames >> framesPerSecond;

		//Wir bergeben die Werte wie vorgesen.
		animations[currentAnim].startFrame		= startFrame;		//Der erste Keyframe
		animations[currentAnim].endFrame		= startFrame + numOfFrames; //der letzt Keyframe
		animations[currentAnim].loopingFrames	= loopingFrames;
		animations[currentAnim].framesPerSecond = framesPerSecond;

		fin >> strLine >> strLine;
		strcpy(animations[currentAnim].strName, strLine.c_str());

		if(IsInString(strLine, "LEGS"))
		{	
			//Weil es viel Configfiles gibt, die den startingframe fr den Torso und die 
			//Beine nicht gleich behalten, muss ich die Werte fr die Beinanimationen
			//wieder Korrigieren. Sie sind schlielich in unterschiedlichen Dateien.

			if(!torsoOffset)
				torsoOffset = animations[LEGS_WALKCR].startFrame - animations[TORSO_GESTURE].startFrame;

			animations[currentAnim].startFrame -= torsoOffset;
			animations[currentAnim].endFrame -= torsoOffset;

		}
		currentAnim++;
	}	
}

void cdMd3::LoadMD3(LPSTR strModel)
{
	//Jede Datei beginnt mit einem Bestimmten Krzel. Unser Character heisst Held.
	//Somit beginnt jeder unserer Files mit dem Krzel Held_. Diese Werte bergeben
	//wir dann an die Importfunktionen.

	if(!SetNormals())
		return;

	char l_mpath[1024], u_mpath[1024], h_mpath[1024], w_mpath[1024];	// Model (lower, upper, head)
	char l_spath[1024], u_spath[1024], h_spath[1024], w_spath[1024];	// Skin
	

	sprintf(h_mpath, "%s_head.md3", strModel);
	sprintf(u_mpath, "%s_upper.md3", strModel);
	sprintf(l_mpath, "%s_lower.md3", strModel);		//An diesem Teil kann man noch einige Arbeit
	sprintf(w_mpath, "%s_plasma.md3", strModel);	//leisten.

	sprintf(h_spath, "%s_head_default.skin", strModel);		//Hier natrlich auch.
	sprintf(u_spath, "%s_upper_default.skin", strModel);
	sprintf(l_spath, "%s_lower_default.skin", strModel);
	sprintf(w_spath, "%s_weapon_default.skin", strModel);

	// Lade Modelteile.
	ImportMD3(&MD3_Head, h_mpath, h_spath);		// head Kopf
	ImportMD3(&MD3_Upper, u_mpath, u_spath);	// upper Torso
	ImportMD3(&MD3_Lower, l_mpath, l_spath);	// lower Beine
	
	// Lade Waffe.
	ImportMD3(&MD3_Weapon, w_mpath, w_spath);	// Weapon Waffe
}

void cdMd3::ImportMD3(MD3Model *MD3, char *strFileName, char *strSkinName)
{
	//Die wichtigste Methode in dieser Klasse. Wir fllen die Werte aus dem MD3Model
	//und formatieren sie so, das wir sie geeignet verwenden knnen.

	long i, m, f, v, CIndex;
	int NormalU, NormalV;
	char *md3name;

	// ffne die Datei.
	fp = fopen(strFileName, "rb");

	//Kopiere den dateinamen
	md3name = new char[strlen(strFileName)+1];
	strcpy(md3name, strFileName);

	// Lese die Headerdatei ein.
	fread(&Header, 1, sizeof(MD3Header), fp);

	if (Header.id =="ID3" || Header.version != 15)
	{
		fclose(fp);
		return;
	}

	// Boneframes einlesen.
	MD3->BoneFrames = new BoneFrame[Header.numBoneFrames];
	fread(MD3->BoneFrames, sizeof(BoneFrame), Header.numBoneFrames, fp);

	// Tags einlesen.
	MD3->Tags = new Tag[Header.numBoneFrames * Header.numTags];
	fread(MD3->Tags, sizeof(Tag), Header.numBoneFrames * Header.numTags, fp);

	MD3->MD3H.numTags = Header.numTags;

	// Meshes einlesen.
	Meshes = new MD3Mesh[Header.numMeshes];
	MD3->MD3Meshes = new MD3Mesh [Header.numMeshes];

	long mesh_offset = ftell(fp);

	// fr jedes Mesh.
	for (i=0; i < Header.numMeshes; i++)
	{
		// Lade die mesh's header
		fseek(fp, mesh_offset, SEEK_SET);
		fread(&Meshes[i].MeshH, sizeof(MeshHeader), 1, fp);

		// Allokiere Speicherplatz fr die Skins und lade sie.
		Meshes[i].Skins = new Skin[Meshes[i].MeshH.numSkins];
		fread(Meshes[i].Skins, sizeof(Skin), Meshes[i].MeshH.numSkins, fp);

		// Allokiere Speicherplatz fr die Faces und lade sie.
		fseek(fp, mesh_offset+Meshes[i].MeshH.tri_start, SEEK_SET);
		Meshes[i].Triangles = new Triangle[Meshes[i].MeshH.numTriangles];
		fread(Meshes[i].Triangles, sizeof(Triangle), Meshes[i].MeshH.numTriangles, fp);

		// Allokiere Speicherplatz fr die Texture Koordinaten und lade sie.
		fseek(fp, mesh_offset+Meshes[i].MeshH.texvec_start, SEEK_SET);
		Meshes[i].TexCoords = new TexCoord[Meshes[i].MeshH.numVertices];
		fread(Meshes[i].TexCoords, sizeof(TexCoord), Meshes[i].MeshH.numVertices, fp);

		// Allokiere Speicherplatz fr die Vertices und lade sie.
		Meshes[i].Frames = new Frame[Meshes[i].MeshH.numMeshFrames];
		fseek(fp, mesh_offset+Meshes[i].MeshH.vertex_start, SEEK_SET);
		for(f=0;f<Meshes[i].MeshH.numMeshFrames;f++)
		{
			Meshes[i].Frames[f].Vertices =  new Vertice[Meshes[i].MeshH.numVertices];
			fread(Meshes[i].Frames[f].Vertices, sizeof(Vertice), Meshes[i].MeshH.numVertices, fp);
		}
		mesh_offset += Meshes[i].MeshH.meshsize;
		
		//Hier werden wichtige Werte an unser Model bergeben, damit wir in weiteren Methoden 
		//damit arbeiten knnen.
		MD3->MD3Meshes[i].MeshH.numTriangles = Meshes[i].MeshH.numTriangles;
		MD3->MD3Meshes[i].MD3H.numMeshes = Header.numMeshes;
	}      

	MD3->MD3Vertices = new MD3Vertice[Header.numMeshes];
	for(m=0; m < Header.numMeshes; m++)
	{
		MD3->MD3Vertices[m].MD3FrameVerts = new MD3FrameVert[Meshes[m].MeshH.numMeshFrames];
		for(f=0; f < Meshes[m].MeshH.numMeshFrames; f++)
		{
			CIndex = 0;

			MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts = new MDLVERTEX[(Meshes[m].MeshH.numTriangles + 100)*3];
			for(v=0; v < Meshes[m].MeshH.numTriangles; v++)
			{
				// Punkt 1 des Traingle
				// x vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.x = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Vec[0] / 64.0f;
				// y vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.y = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Vec[1] / 64.0f;
				// z vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.z = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Vec[2] / 64.0f;
				// texture-coordinate
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[0] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[0]].texvec[0];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[1] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[0]].texvec[1];
				// normal 
				NormalU = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[0];
				NormalV = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[1];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Normal = Normals[NormalU][NormalV];
			
				CIndex++;
				// Punkt 2 des Traingle
				// x vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.x = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[1]].Vec[0] / 64.0f;
				// y vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.y = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[1]].Vec[1] / 64.0f;
				// z vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.z = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[1]].Vec[2] / 64.0f;
				// texture-coordinate
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[0] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[1]].texvec[0];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[1] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[1]].texvec[1];
				// normal 
				NormalU = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[0];
				NormalV = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[1];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Normal = Normals[NormalU][NormalV];
			
				CIndex++;
				// Punkt 3 des Traingle
				// x vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.x = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[2]].Vec[0] / 64.0f;
				// y vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.y = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[2]].Vec[1] / 64.0f;
				// z vertex
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Position.z = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[2]].Vec[2] / 64.0f;
				// texture-coordinate
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[0] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[2]].texvec[0];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Texture[1] = Meshes[m].TexCoords[Meshes[m].Triangles[v].vertex[2]].texvec[1];
				// normal 
				NormalU = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[0];
				NormalV = Meshes[m].Frames[f].Vertices[Meshes[m].Triangles[v].vertex[0]].Normal[1];
				MD3->MD3Vertices[m].MD3FrameVerts[f].MD3Verts[CIndex].Normal = Normals[NormalU][NormalV];

				CIndex++;
			}
		}
	}

	// Lade Skins
	LoadSkin(MD3, strSkinName);

	// we're done, close the file
	fclose(fp);

	Header.numBoneFrames -= 1;
}

void cdMd3::LoadSkin(MD3Model *MD3, char *filename)
{

	//Hier werden die Skins der Meshes geladen und abgespeichert. In dem weiteren Verlauf
	//brauchen wir sie noch zum rendern und richtigen texturieren der Models.

	ifstream fin(filename);

	if(fin.fail())
		return;

	string strLine = "";
	string path = "";
	int textureNameStart = 0, j, i;
	char texturename[25];

	TexNR=0;

	while(getline(fin, strLine))	//gehe durch jede Zeile unserer Skinfile.
	{
		for(i=0; i<Header.numMeshes; i++)
		{
			if( IsInString(strLine, Meshes[i].MeshH.name) )	//und teste auf einen String.
			{			
				for(j=strLine.length()-1; j>0; j--)
				{
					if(strLine[j] == '/')
					{
						textureNameStart = j + 1;
						break;
					}	
				}

				strcpy(texturename, &strLine[textureNameStart]);

				//Sie werden aus den Skinfiles gelesen und in dem Array TexInf gespeichert.
				D3DXCreateTextureFromFile(D3D_Device, (const char *)texturename, &TexInf[TexNR]);
				SetMeshTexture(MD3, Meshes[i].MeshH.name, TexInf[TexNR]);
				TexNR++;
			}
		}
	}

	fin.close();
}

int cdMd3::SetMeshTexture(MD3Model *MD3, char *meshname, LPDIRECT3DTEXTURE8 tex)
{	
	//Das Model hat seine eigenen Struktueren dafr. Speichern wir sie also darin.
	for (int i=0; i < Header.numMeshes; i++)
	{
		if (!strcmp(Meshes[i].MeshH.name, meshname))
		{
			MD3->MD3Meshes[i].texture = tex;		//setzten der Textur in unserem 
			MD3->MD3Meshes[i].settexture = 1;		//Model.
			return i;
		}
	}
	return -1;
}

void cdMd3::Render(D3DXMATRIX matWorld)
{
	//Kommen wir nun zum angenehmen Teil des Turorials. Dem Rendern.
	int i;

	UpdateFrames(&mLower);		//Update Frames ist dafr verantworlich den Keyframe zu 
   	UpdateFrames(&mUpper);		//wechseln. Damit man den Character zum bewegen bringt.

	ModelWorld = matWorld;		//Worldmatrix.

	D3DXMatrixIdentity(&matTemp);				//Wir rotieren das Model in die richtige Richtung.
	D3DXMatrixRotationX(&MatX, -3.141f / 2);	
	D3DXMatrixRotationY(&MatY, 3.141f / 2);
	D3DXMatrixMultiply(&matTemp, &MatX, &MatY);
	D3DXMatrixMultiply(&ModelWorld, &matTemp, &ModelWorld);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld);

	ModelWorld2 = ModelWorld;

	D3D_Device->SetVertexShader(MDLVERTEX_FVF);

	for (i=0; i<MD3_Lower.MD3Meshes[i].MD3H.numMeshes; i++)
	{
		//Zuerst werden die Beine gerendert und korrekt texturiert.
		D3D_Device->SetTexture( 0, MD3_Lower.MD3Meshes[i].texture );
		D3D_Device->DrawPrimitiveUP(D3DPT_TRIANGLELIST, MD3_Lower.MD3Meshes[i].MeshH.numTriangles, MD3_Lower.MD3Vertices[i].MD3FrameVerts[mLower.Frame].MD3Verts, sizeof(MDLVERTEX));
	}

	//wir mssen die Einzelteile der Meshes richtig verlinken. Verantworlich dafr ist die Funktion 
	//DoMatrix. Sie veranlasst das matTorsoResult den "richtigen Dreh" bekommt.
	DoMatrix(&MD3_Lower, "tag_torso", &mLower, &matTorsoResult, false);
	D3DXMatrixMultiply(&ModelWorld, &matTorsoResult, &ModelWorld);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld);

	for (i=0; i<MD3_Upper.MD3Meshes[i].MD3H.numMeshes; i++)
	{
		//dann wird der Oberkrper gerendert.
		D3D_Device->SetTexture( 0, MD3_Upper.MD3Meshes[i].texture );
		D3D_Device->DrawPrimitiveUP(D3DPT_TRIANGLELIST, MD3_Upper.MD3Meshes[i].MeshH.numTriangles, MD3_Upper.MD3Vertices[i].MD3FrameVerts[mUpper.Frame].MD3Verts, sizeof(MDLVERTEX));
	}

	DoMatrix(&MD3_Upper, "tag_head", &mUpper, &matHeadResult, true);
	D3DXMatrixMultiply(&ModelWorld, &matHeadResult, &ModelWorld);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld);

	//Zuletzt werden die Beine transliert, rotiert und gerendert.
	for (i=0; i<MD3_Head.MD3Meshes[i].MD3H.numMeshes; i++)
	{
		D3D_Device->SetTexture( 0, MD3_Head.MD3Meshes[i].texture );
		D3D_Device->DrawPrimitiveUP(D3DPT_TRIANGLELIST, MD3_Head.MD3Meshes[i].MeshH.numTriangles, MD3_Head.MD3Vertices[i].MD3FrameVerts[0].MD3Verts, sizeof(MDLVERTEX));
	}

	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);

	//Die Waffe muss ebenfalls gerendert werden.
	DoMatrix(&MD3_Upper, "tag_weapon", &mUpper, &matWeapon, false);
	D3DXMatrixMultiply(&ModelWorld, &matWeapon, &matTorsoResult);
	D3DXMatrixMultiply(&ModelWorld, &ModelWorld, &ModelWorld2);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld);
	
	for (i=0; i<MD3_Weapon.MD3Meshes[i].MD3H.numMeshes; i++)
	{
		D3D_Device->SetTexture( 0, MD3_Weapon.MD3Meshes[i].texture );
		D3D_Device->DrawPrimitiveUP(D3DPT_TRIANGLELIST, MD3_Weapon.MD3Meshes[i].MeshH.numTriangles, MD3_Weapon.MD3Vertices[i].MD3FrameVerts[0].MD3Verts, sizeof(MDLVERTEX));
	}

	D3DXMatrixIdentity(&ModelWorld);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld);
	D3DXMatrixIdentity(&ModelWorld2);
	D3D_Device->SetTransform(D3DTS_WORLD, &ModelWorld2);

	D3D_Device->SetTransform(D3DTS_WORLD, &matWorld);
}

void cdMd3::DoMatrix(MD3Model *ModelPart, string Link, tAnimationInfo *MD3, D3DXMATRIX *ModelMatrix, bool IsHead)
{
	int i=0;

	//Die Tags spielen hier eine gre Rolle. Das Model mss schliesslich bei jeder 
	//Animationphase korrekt gerendert werden und zusammen haften.

	for(i=0; i<ModelPart->MD3H.numTags; i++)
	{
		if(Link == ModelPart->Tags[i].name)
		{
			MatrixFrom = Get4x4Matrix(*ModelPart, MD3->Frame * ModelPart->MD3H.numTags + i);
			PosFrom.x = ModelPart->Tags[MD3->Frame * ModelPart->MD3H.numTags + i].position[0];
			PosFrom.y = ModelPart->Tags[MD3->Frame * ModelPart->MD3H.numTags + i].position[1];
			PosFrom.z = ModelPart->Tags[MD3->Frame * ModelPart->MD3H.numTags + i].position[2];
		}
	}

	MatrixFrom.m[3][0] = PosFrom.x;
	MatrixFrom.m[3][1] = PosFrom.y;
	MatrixFrom.m[3][2] = PosFrom.z;
	MatrixFrom.m[3][3] = 1;

    *ModelMatrix = MatrixFrom;
}

void cdMd3::SetLowerAni(long Ani)
{
	//Wir bergeben die Animationen an unsere Animationstruktur mLower.
    mLower.framesPerSecond = 0;
    mLower.startFrame = animations[Ani].startFrame;
    mLower.endFrame = animations[Ani].endFrame;
	mLower.NextFrame = mLower.startFrame;
    mLower.Frame = mLower.startFrame;
}

void cdMd3::SetUpperAni(long Ani)
{
	//Wir bergeben die Animationen an unsere Animationstruktur mUpper.
    mUpper.framesPerSecond = 0;
    mUpper.startFrame = animations[Ani].startFrame;
    mUpper.endFrame = animations[Ani].endFrame;
	mUpper.NextFrame = mUpper.startFrame;
    mUpper.Frame = mUpper.startFrame;
}

void cdMd3::UpdateFrames(tAnimationInfo *MD3)
{
	//Die Keyframes werden hier anhand der Frames dargestellt. Die Animation sollte
	//auf jedem Rechner gleich schnell laufen.
	MD3->tElapsed = QPTimer() - (MD3->tLastFrame);
	MD3->tFactor = MD3->tElapsed / (MD3->framesPerSecond + 0.1);

	if(MD3->tFactor >= 1)
	{
		 MD3->Frame = MD3->NextFrame;
		 MD3->NextFrame++;

		 if(MD3->NextFrame > MD3->endFrame - 1)
			 MD3->NextFrame = MD3->startFrame;

		 MD3->tLastFrame = QPTimer();
		 MD3->tFactor = 0;
	}
}

bool cdMd3::SetNormals()
{
	//Die Normalen werden fr die korrekte Verwendung vorbereitet und in den Variablen abgespeichert.
	float A, B;
    
	for(int i=0; i<=254; i++)
	{
		for(int j=0; j<=254; j++)
		{
			A = 2 * i * 3.14f / 255;
            B = 2 * j * 3.14f / 255;
            Normals[i][j].x = cos(B) * sin(A);
            Normals[i][j].y = sin(B) * sin(A);
            Normals[i][j].z = cos(A);
		}
	}

	return true;
}

bool IsInString(string strString, string strSubString)
{
	//Diese Funktion ist dafr verantwortlich, Strings in anderen zu suchen.
	if(strString.length() <= 0 || strSubString.length() <= 0) return false;

	unsigned int index = strString.find(strSubString);

	if(index >= 0 && index < strString.length())
		return true;

	return false;
}

double QPTimer()
{
	//QPTimer gibt smtliche Computergeschwindigkeiten wieder.
	double QTimer;
	union _LARGE_INTEGER takt, dauer;
	QueryPerformanceFrequency(&takt);
	QueryPerformanceCounter(&dauer);

	QTimer = (double)dauer.QuadPart/(double)takt.QuadPart;
	return QTimer;
}

D3DXMATRIX Get4x4Matrix(MD3Model ModelPart, long TagID)
{
	D3DXMATRIX MatOut; 

	MatOut.m[0][0] = 1;//ModelPart.Tags[TagID].rotation[0][0];
	MatOut.m[1][0] = 0;//ModelPart.Tags[TagID].rotation[0][1];
	MatOut.m[2][0] = 0;//ModelPart.Tags[TagID].rotation[0][2];

	MatOut.m[0][1] = 0;//ModelPart.Tags[TagID].rotation[1][0];
	MatOut.m[1][1] = 1;//ModelPart.Tags[TagID].rotation[1][1];
	MatOut.m[2][1] = 0;//ModelPart.Tags[TagID].rotation[1][2];

	MatOut.m[0][2] = 0;//ModelPart.Tags[TagID].rotation[2][0];
	MatOut.m[1][2] = 0;//ModelPart.Tags[TagID].rotation[2][1];
	MatOut.m[2][2] = 1;//ModelPart.Tags[TagID].rotation[2][2];
	MatOut.m[3][3] = 1;

	MatOut.m[0][3] = 0;
	MatOut.m[1][3] = 0;
	MatOut.m[2][3] = 0;

	return MatOut;
}